/* Copyright (C) 1993 Ulrich Drepper

This file is intended to be included in the GNU C Library and the
Linux C Library. So the copyright notice will be:

Copyright (C) 1993 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.


For now the file can be distributed under the LGPL.  */

#ifndef _SEARCH_H
#define _SEARCH_H

#define __need_size_t
#define __need_NULL
#include <stddef.h>

/* The tsearch routines are very interesting. They make many
 * assumptions about the compiler. It assumpts that the first field
 * in node must be the "key" field, which points to the datum.
 * Everything depends on that. It is a very tricky stuff. H.J.
 */
/* For tsearch */
typedef enum { preorder, postorder, endorder, leaf } VISIT;

char *tsearch( char *key, char **rootp, int (*compar)());
char *tfind( char *key, char **rootp, int (*compar)());
char *tdelete( char *key, char **rootp, int (*compar)());
void trecurse(char *root, void (*action)(), int level);
void twalk(char *root, void (*action)());

#endif /* search.h */
